
import { _decorator, Component, Node, Vec3, Prefab, instantiate, RigidBody, physics } from 'cc';
import { AddForce } from './AddForce';
const { ccclass, property } = _decorator;

@ccclass('GameController')
export class GameController extends Component {
	@property({ type: Prefab })
	public ball: Prefab = null as any;

	private nodes: Node[] = [];

	start () {
		// [3]
	}

	addBall () {
		let b: Node = instantiate(this.ball);
		this.node.addChild(b);
		b.setPosition(new Vec3(0, 3, 0));
		this.nodes.push(b);
		useCCD(b.getComponent(RigidBody)!, true);
	}

	addForce () {
		for (let i = 0; i < this.nodes.length; i++) {
			let af: AddForce = this.nodes[i].getComponent(AddForce) as any;
			af.addForce();
		}
	}


	// update (deltaTime: number) {
	//     // [4]
	// }
}


function useCCD (rb: RigidBody, v: boolean) {
	if (physics.PhysicsSystem.PHYSICS_AMMO && rb) {
		rb.body!.impl.setCcdMotionThreshold(v?0.01:0);
		rb.body!.impl.setCcdSweptSphereRadius(v?0.05:0);
	}
}


/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
 */
